searchData={"items":[{"type":"module","title":"Mcpixir.Agents.Prompts.SystemPromptBuilder","doc":"Builds system prompts for MCP agents.","ref":"Mcpixir.Agents.Prompts.SystemPromptBuilder.html"},{"type":"function","title":"Mcpixir.Agents.Prompts.SystemPromptBuilder.build/1","doc":"Builds a system prompt with the given tools.","ref":"Mcpixir.Agents.Prompts.SystemPromptBuilder.html#build/1"},{"type":"function","title":"Mcpixir.Agents.Prompts.SystemPromptBuilder.build_tools_description/1","doc":"Builds a description of available tools for the prompt.","ref":"Mcpixir.Agents.Prompts.SystemPromptBuilder.html#build_tools_description/1"},{"type":"module","title":"Mcpixir.Agents.Prompts.Templates","doc":"Templates for MCP agent prompts.","ref":"Mcpixir.Agents.Prompts.Templates.html"},{"type":"function","title":"Mcpixir.Agents.Prompts.Templates.base_system_prompt/0","doc":"Base system prompt template for MCP agents.","ref":"Mcpixir.Agents.Prompts.Templates.html#base_system_prompt/0"},{"type":"function","title":"Mcpixir.Agents.Prompts.Templates.task_specific_prompt/1","doc":"Template for task-specific prompts.","ref":"Mcpixir.Agents.Prompts.Templates.html#task_specific_prompt/1"},{"type":"module","title":"Mcpixir.Application","doc":"Application module for Mcpixir that handles LangChain integration and other application-level concerns.","ref":"Mcpixir.Application.html"},{"type":"function","title":"Mcpixir.Application.anthropic_module/0","doc":"Gets the Anthropic module if available.","ref":"Mcpixir.Application.html#anthropic_module/0"},{"type":"function","title":"Mcpixir.Application.format_messages_for_langchain/1","doc":"Formats messages for LangChain integration.\nSafely handles the conversion, falling back to the original messages if LangChain is unavailable.","ref":"Mcpixir.Application.html#format_messages_for_langchain/1"},{"type":"function","title":"Mcpixir.Application.langchain_available?/0","doc":"Checks if LangChain integration is available.\nAlways use this function instead of directly checking Code.ensure_loaded.","ref":"Mcpixir.Application.html#langchain_available?/0"},{"type":"function","title":"Mcpixir.Application.langchain_models_module/0","doc":"Gets the LangChain models module if available.","ref":"Mcpixir.Application.html#langchain_models_module/0"},{"type":"function","title":"Mcpixir.Application.load_optional_dependencies/0","doc":"Load optional dependencies like LangChain\n\nReturns a boolean indicating whether LangChain is available.","ref":"Mcpixir.Application.html#load_optional_dependencies/0"},{"type":"function","title":"Mcpixir.Application.openai_module/0","doc":"Gets the OpenAI module if available.","ref":"Mcpixir.Application.html#openai_module/0"},{"type":"module","title":"Mcpixir.IntermediateStep","doc":"Represents an intermediate step in agent execution.","ref":"Mcpixir.IntermediateStep.html"},{"type":"type","title":"Mcpixir.IntermediateStep.t/0","doc":"","ref":"Mcpixir.IntermediateStep.html#t:t/0"},{"type":"module","title":"Mcpixir.LLMClient","doc":"Client for interacting with LLM providers.\n\nThis module defines the interface for LLM clients and provides\nbasic implementation that delegates to provider-specific modules.","ref":"Mcpixir.LLMClient.html"},{"type":"function","title":"Mcpixir.LLMClient.new/1","doc":"Creates a new LLM client with the given configuration.","ref":"Mcpixir.LLMClient.html#new/1"},{"type":"function","title":"Mcpixir.LLMClient.run/2","doc":"Runs a query using the LLM client.","ref":"Mcpixir.LLMClient.html#run/2"},{"type":"type","title":"Mcpixir.LLMClient.t/0","doc":"","ref":"Mcpixir.LLMClient.html#t:t/0"},{"type":"module","title":"Mcpixir.LLMClient.Anthropic","doc":"Anthropic-specific implementation of the LLM client.\n\nThis module handles communication with Anthropic's API (Claude models),\nusing the LangChain library with support for tool calling.","ref":"Mcpixir.LLMClient.Anthropic.html"},{"type":"behaviour","title":"Mcpixir.LLMClient.Base","doc":"Base behaviour for LLM clients.\n\nThis module defines the common behavior that all LLM client providers\nmust implement. It allows for a consistent interface when working with\ndifferent language models.","ref":"Mcpixir.LLMClient.Base.html"},{"type":"callback","title":"Mcpixir.LLMClient.Base.run/2","doc":"Run the LLM with the given messages and return a response.\n\nThe messages should be a list of structured message maps containing at least:\n- role: The role of the message sender (system, user, assistant)\n- content: The content of the message\n\nReturns {:ok, response} where response is a map with at least:\n- role: always \"assistant\"\n- content: The generated response text\n- tool_calls: (optional) List of tool calls if the LLM wishes to use tools","ref":"Mcpixir.LLMClient.Base.html#c:run/2"},{"type":"module","title":"Mcpixir.LLMClient.LangChain","doc":"LangChain-specific implementation of the LLM client.\n\nThis module handles using a pre-configured LangChain model instance\nthat is provided directly by the user.","ref":"Mcpixir.LLMClient.LangChain.html"},{"type":"module","title":"Mcpixir.LLMClient.Mock","doc":"Mock implementation of the LLM client.\n\nThis module provides a mock implementation that can be used for testing\nor when no other LLM provider is available.","ref":"Mcpixir.LLMClient.Mock.html"},{"type":"module","title":"Mcpixir.LLMClient.OpenAI","doc":"OpenAI-specific implementation of the LLM client.\n\nThis module handles communication with OpenAI's API, using\nthe LangChain library with support for tool calling.","ref":"Mcpixir.LLMClient.OpenAI.html"},{"type":"module","title":"Mcpixir.Logging","doc":"Logging functionality for MCP.","ref":"Mcpixir.Logging.html"},{"type":"function","title":"Mcpixir.Logging.create_middleware/1","doc":"Creates a logger middleware for use with connectors.","ref":"Mcpixir.Logging.html#create_middleware/1"},{"type":"function","title":"Mcpixir.Logging.debug/2","doc":"Logs a debug message.","ref":"Mcpixir.Logging.html#debug/2"},{"type":"function","title":"Mcpixir.Logging.error/2","doc":"Logs an error message.","ref":"Mcpixir.Logging.html#error/2"},{"type":"function","title":"Mcpixir.Logging.info/2","doc":"Logs an info message.","ref":"Mcpixir.Logging.html#info/2"},{"type":"function","title":"Mcpixir.Logging.log/3","doc":"Logs a message with the specified level.","ref":"Mcpixir.Logging.html#log/3"},{"type":"function","title":"Mcpixir.Logging.set_level/1","doc":"Sets the log level.","ref":"Mcpixir.Logging.html#set_level/1"},{"type":"function","title":"Mcpixir.Logging.warning/2","doc":"Logs a warning message.","ref":"Mcpixir.Logging.html#warning/2"},{"type":"module","title":"Mcpixir.Message","doc":"Represents a message in a conversation.","ref":"Mcpixir.Message.html"},{"type":"type","title":"Mcpixir.Message.t/0","doc":"","ref":"Mcpixir.Message.html#t:t/0"},{"type":"module","title":"Mcpixir.Tool","doc":"Represents a tool that can be executed by MCP.","ref":"Mcpixir.Tool.html"},{"type":"type","title":"Mcpixir.Tool.t/0","doc":"","ref":"Mcpixir.Tool.html#t:t/0"},{"type":"task","title":"mix mcpixir","doc":"Mcpixir example tasks demonstrating the library's capabilities.\n\nMcpixir is an Elixir library to connect LLMs (Language Learning Models)\nto MCP (Machine Control Protocol) servers.","ref":"Mix.Tasks.Mcpixir.html"},{"type":"task","title":"Available Tasks - mix mcpixir","doc":"* `mix mcpixir.chat`       - Runs a chat example with an LLM\n  * `mix mcpixir.airbnb`     - Runs an Airbnb search example with an LLM\n  * `mix mcpixir.blender`    - Runs a Blender 3D modeling example with an LLM\n  * `mix mcpixir.browser`    - Runs a web browser automation example with an LLM\n  * `mix mcpixir.filesystem` - Runs a filesystem interaction example with an LLM\n  * `mix mcp.http`       - Runs an HTTP MCP server example with an LLM\n  * `mix mcp.multi`      - Runs a multi-server example with an LLM","ref":"Mix.Tasks.Mcpixir.html#module-available-tasks"},{"type":"task","title":"API Keys - mix mcpixir","doc":"To use these examples, you'll need valid API keys for either OpenAI or Anthropic.\nSet them in your environment variables:\n\n```\nexport OPENAI_API_KEY=your-openai-key\nexport ANTHROPIC_API_KEY=your-anthropic-key\n```","ref":"Mix.Tasks.Mcpixir.html#module-api-keys"},{"type":"task","title":"Global Options - mix mcpixir","doc":"Most tasks support these common options:\n\n  * `--provider=[openai|anthropic]` - LLM provider to use\n  * `--model=MODEL` - Specific LLM model to use\n  * `--query=QUERY` - The query to send to the LLM","ref":"Mix.Tasks.Mcpixir.html#module-global-options"},{"type":"task","title":"Examples - mix mcpixir","doc":"```\nmix mcpixir               # Show this help\nmix mcpixir.chat          # Run chat example with OpenAI\nmix mcpixir.airbnb --provider=anthropic  # Run Airbnb example with Anthropic\n```","ref":"Mix.Tasks.Mcpixir.html#module-examples"},{"type":"task","title":"mix mcpixir.airbnb","doc":"Demonstrates using Mcpixir to connect an LLM to Airbnb through MCP tools.\n\nThis task allows searching for accommodations on Airbnb using\nnatural language queries processed by an LLM.","ref":"Mix.Tasks.Mcpixir.Airbnb.html"},{"type":"task","title":"Usage - mix mcpixir.airbnb","doc":"mix mcpixir.airbnb","ref":"Mix.Tasks.Mcpixir.Airbnb.html#module-usage"},{"type":"task","title":"Options - mix mcpixir.airbnb","doc":"--provider=PROVIDER   LLM provider (openai or anthropic, default: anthropic)\n    --model=MODEL         Model to use (default: claude-3-sonnet-20240229 for Anthropic, gpt-4o for OpenAI)\n    --query=QUERY         Query to send to the LLM (default is Barcelona search)\n    --config=PATH         Path to Airbnb MCP config file (optional)","ref":"Mix.Tasks.Mcpixir.Airbnb.html#module-options"},{"type":"task","title":"Examples - mix mcpixir.airbnb","doc":"mix mcpixir.airbnb\n    mix mcpixir.airbnb --provider=openai\n    mix mcpixir.airbnb --query=\"Find me a beachfront place in Miami for 4 people in December\"","ref":"Mix.Tasks.Mcpixir.Airbnb.html#module-examples"},{"type":"task","title":"mix mcpixir.blender","doc":"Demonstrates using Mcpixir to control Blender 3D via MCP.\n\nThis task allows controlling Blender through natural language commands\nprocessed by an LLM.","ref":"Mix.Tasks.Mcpixir.Blender.html"},{"type":"task","title":"Prerequisites - mix mcpixir.blender","doc":"You need to have the Blender MCP addon installed from:\nhttps://github.com/ahujasid/blender-mcp\n\nMake sure the addon is enabled in Blender preferences and the\nWebSocket server is running before executing this task.","ref":"Mix.Tasks.Mcpixir.Blender.html#module-prerequisites"},{"type":"task","title":"Usage - mix mcpixir.blender","doc":"mix mcpixir.blender","ref":"Mix.Tasks.Mcpixir.Blender.html#module-usage"},{"type":"task","title":"Options - mix mcpixir.blender","doc":"--provider=PROVIDER   LLM provider (openai or anthropic, default: anthropic)\n    --model=MODEL         Model to use (default: claude-3-sonnet-20240229 for Anthropic, gpt-4o for OpenAI)\n    --query=QUERY         Query to send to the LLM (default is a cube creation)\n    --command=COMMAND     Command to launch Blender MCP server (default: \"uvx blender-mcp\")","ref":"Mix.Tasks.Mcpixir.Blender.html#module-options"},{"type":"task","title":"Examples - mix mcpixir.blender","doc":"mix mcpixir.blender\n    mix mcpixir.blender --provider=openai\n    mix mcpixir.blender --query=\"Create a red torus floating above a blue plane\"","ref":"Mix.Tasks.Mcpixir.Blender.html#module-examples"},{"type":"task","title":"mix mcpixir.browser","doc":"Demonstrates using Mcpixir to control a web browser via Playwright MCP.\n\nThis task allows controlling a web browser through natural language commands\nprocessed by an LLM.","ref":"Mix.Tasks.Mcpixir.Browser.html"},{"type":"task","title":"Usage - mix mcpixir.browser","doc":"mix mcpixir.browser","ref":"Mix.Tasks.Mcpixir.Browser.html#module-usage"},{"type":"task","title":"Options - mix mcpixir.browser","doc":"--provider=PROVIDER   LLM provider (openai or anthropic, default: openai)\n    --model=MODEL         Model to use (default: gpt-4o for OpenAI, claude-3-opus-20240229 for Anthropic)\n    --query=QUERY         Query to send to the LLM (default is GitHub navigation)\n    --config=PATH         Path to Browser MCP config file (optional)\n    --url=URL             Initial URL to navigate to (default: https://github.com/mcp-use/mcp-use)","ref":"Mix.Tasks.Mcpixir.Browser.html#module-options"},{"type":"task","title":"Examples - mix mcpixir.browser","doc":"mix mcpixir.browser\n    mix mcpixir.browser --provider=anthropic\n    mix mcpixir.browser --url=https://elixir-lang.org --query=\"Summarize the Elixir homepage\"","ref":"Mix.Tasks.Mcpixir.Browser.html#module-examples"},{"type":"task","title":"mix mcpixir.chat","doc":"Demonstrates a basic chat interaction with an LLM using Mcpixir.\n\nThis task connects to an LLM (OpenAI or Anthropic) and allows\nfor a simple chat interaction using weather tools.","ref":"Mix.Tasks.Mcpixir.Chat.html"},{"type":"task","title":"Usage - mix mcpixir.chat","doc":"mix mcpixir.chat","ref":"Mix.Tasks.Mcpixir.Chat.html#module-usage"},{"type":"task","title":"Options - mix mcpixir.chat","doc":"--provider=PROVIDER   LLM provider (openai or anthropic, default: openai)\n    --model=MODEL         Model to use (default: gpt-4o for OpenAI, claude-3-opus-20240229 for Anthropic)\n    --query=QUERY         Query to send to the LLM (default: \"What's the weather like in San Francisco?\")","ref":"Mix.Tasks.Mcpixir.Chat.html#module-options"},{"type":"task","title":"Examples - mix mcpixir.chat","doc":"mix mcpixir.chat\n    mix mcpixir.chat --provider=anthropic\n    mix mcpixir.chat --model=gpt-4o --query=\"What's the weather like in London?\"","ref":"Mix.Tasks.Mcpixir.Chat.html#module-examples"},{"type":"task","title":"mix mcpixir.filesystem","doc":"Demonstrates using Mcpixir to interact with the filesystem via MCP.\n\nThis task allows querying and manipulating the filesystem using\nnatural language commands processed by an LLM.","ref":"Mix.Tasks.Mcpixir.Filesystem.html"},{"type":"task","title":"Usage - mix mcpixir.filesystem","doc":"mix mcpixir.filesystem","ref":"Mix.Tasks.Mcpixir.Filesystem.html#module-usage"},{"type":"task","title":"Options - mix mcpixir.filesystem","doc":"--provider=PROVIDER   LLM provider (openai or anthropic, default: openai)\n    --model=MODEL         Model to use (default: gpt-4o for OpenAI, claude-3-sonnet-20240229 for Anthropic)\n    --query=QUERY         Query to send to the LLM (default lists files in current dir)\n    --path=PATH           Directory path to use for filesystem operations (default: current directory)","ref":"Mix.Tasks.Mcpixir.Filesystem.html#module-options"},{"type":"task","title":"Examples - mix mcpixir.filesystem","doc":"mix mcp.filesystem\n    mix mcp.filesystem --provider=anthropic\n    mix mcp.filesystem --path=/tmp --query=\"Create a text file named test.txt with hello world in it\"","ref":"Mix.Tasks.Mcpixir.Filesystem.html#module-examples"},{"type":"task","title":"mix mcpixir.http","doc":"Demonstrates using Mcpixir to connect to an MCP server via HTTP.\n\nThis task connects to an MCP server running on a specific HTTP port\nand sends queries via an LLM.","ref":"Mix.Tasks.Mcpixir.Http.html"},{"type":"task","title":"Prerequisites - mix mcpixir.http","doc":"Before running this task, you need to start the Playwright MCP server\nin another terminal with:\n\n    npx @playwright/mcp@latest --port 8931","ref":"Mix.Tasks.Mcpixir.Http.html#module-prerequisites"},{"type":"task","title":"Usage - mix mcpixir.http","doc":"mix mcpixir.http","ref":"Mix.Tasks.Mcpixir.Http.html#module-usage"},{"type":"task","title":"Options - mix mcpixir.http","doc":"--provider=PROVIDER   LLM provider (openai or anthropic, default: openai)\n    --model=MODEL         Model to use (default: gpt-4o for OpenAI, claude-3-sonnet-20240229 for Anthropic)\n    --query=QUERY         Query to send to the LLM (default is restaurant search)\n    --url=URL             MCP server URL (default: http://localhost:8931/sse)","ref":"Mix.Tasks.Mcpixir.Http.html#module-options"},{"type":"task","title":"Examples - mix mcpixir.http","doc":"mix mcpixir.http\n    mix mcpixir.http --provider=anthropic\n    mix mcpixir.http --query=\"Find hotels in New York with rooftop bars\"","ref":"Mix.Tasks.Mcpixir.Http.html#module-examples"},{"type":"task","title":"mix mcpixir.multi","doc":"Demonstrates using Mcpixir with multiple MCP servers at once.\n\nThis task shows how to:\n1. Configure multiple MCP servers\n2. Create and manage sessions for each server\n3. Use tools from different servers in a single agent","ref":"Mix.Tasks.Mcpixir.Multi.html"},{"type":"task","title":"Usage - mix mcpixir.multi","doc":"mix mcpixir.multi","ref":"Mix.Tasks.Mcpixir.Multi.html#module-usage"},{"type":"task","title":"Options - mix mcpixir.multi","doc":"--provider=PROVIDER   LLM provider (openai or anthropic, default: anthropic)\n    --model=MODEL         Model to use (default: claude-3-sonnet-20240229 for Anthropic, gpt-4o for OpenAI)\n    --query=QUERY         Query to send to the LLM (default is Barcelona travel query)\n    --servers=SERVERS     Comma-separated list of servers to use (default: \"airbnb,playwright,filesystem\")","ref":"Mix.Tasks.Mcpixir.Multi.html#module-options"},{"type":"task","title":"Examples - mix mcpixir.multi","doc":"mix mcpixir.multi\n    mix mcpixir.multi --provider=openai\n    mix mcpixir.multi --servers=airbnb,playwright","ref":"Mix.Tasks.Mcpixir.Multi.html#module-examples"},{"type":"task","title":"mix mcpixir.release","doc":"Handles the release process for Mcpixir.\n\nThis task automates the release process, including:\n- Verifying the project is in a clean state\n- Updating version numbers\n- Updating the CHANGELOG\n- Creating a git tag\n- Publishing to Hex.pm","ref":"Mix.Tasks.Mcpixir.Release.html"},{"type":"task","title":"Usage - mix mcpixir.release","doc":"mix mcpixir.release VERSION\n\nWhere VERSION is the new version number in the format MAJOR.MINOR.PATCH.","ref":"Mix.Tasks.Mcpixir.Release.html#module-usage"},{"type":"task","title":"Examples - mix mcpixir.release","doc":"mix mcpixir.release 0.2.0\n    mix mcpixir.release 1.0.0","ref":"Mix.Tasks.Mcpixir.Release.html#module-examples"},{"type":"module","title":"Mcpixir","doc":"Mcpixir is a library for connecting LLMs (Language Learning Models) to MCP (Machine Control Protocol) servers.\n\nThis library enables AI agents to access external tools like web browsing, file operations,\nand specific applications through a unified interface. It's designed to connect any LLM\nto various tools through MCP servers.","ref":"Mcpixir.html"},{"type":"module","title":"Main Features - Mcpixir","doc":"* **LLM Integration**: Connect any LLM with tool-calling capabilities (OpenAI, Anthropic, etc.)\n* **Multiple Connection Types**: Support for HTTP, WebSocket, and stdio connections\n* **Server Management**: Use multiple MCP servers simultaneously, with dynamic server selection\n* **Comprehensive Tool Access**: Interact with web browsers, file systems, and specialized applications\n* **Easy Configuration**: Simple configuration options via code or JSON files","ref":"Mcpixir.html#module-main-features"},{"type":"module","title":"Getting Started - Mcpixir","doc":"Create a client and agent:\n\n```elixir\n# Create a client with a configuration\nclient = Mcpixir.new_client(%{\n  mcpServers: %{\n    browser: %{\n      command: \"npx\",\n      args: [\"@playwright/mcp@latest\"]\n    }\n  }\n})\n\n# Create an agent with an LLM\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: %{\n    provider: :openai,\n    model: \"gpt-4o\"\n  },\n  client: client\n})\n\n# Run a query\n{:ok, result, updated_agent} = Mcpixir.run(agent, \"Search for Elixir libraries on GitHub\")\n```","ref":"Mcpixir.html#module-getting-started"},{"type":"module","title":"Examples - Mcpixir","doc":"The library includes several Mix tasks for demonstrating various use cases:\n\n```bash\n# Run the browser example\nmix mcp.browser\n\n# Run the Airbnb search example with Anthropic\nmix mcp.airbnb --provider=anthropic\n```\n\nSee the README for more detailed examples and the full API reference.","ref":"Mcpixir.html#module-examples"},{"type":"function","title":"Mcpixir.new_agent/1","doc":"Creates a new MCP agent with the given configuration.","ref":"Mcpixir.html#new_agent/1"},{"type":"function","title":"Mcpixir.new_client/1","doc":"Creates a new MCP client with the given configuration.","ref":"Mcpixir.html#new_client/1"},{"type":"function","title":"Mcpixir.run/2","doc":"Runs a query using an MCP agent.","ref":"Mcpixir.html#run/2"},{"type":"function","title":"Mcpixir.run_tool/3","doc":"Executes a specific tool using an MCP agent.","ref":"Mcpixir.html#run_tool/3"},{"type":"function","title":"Mcpixir.set_log_level/1","doc":"Sets the log level for the MCP library.","ref":"Mcpixir.html#set_log_level/1"},{"type":"function","title":"Mcpixir.version/0","doc":"Returns the version of the MCP library.","ref":"Mcpixir.html#version/0"},{"type":"module","title":"Mcpixir.Client","doc":"Client for managing MCP connections and sessions.","ref":"Mcpixir.Client.html"},{"type":"function","title":"Mcpixir.Client.create_session/3","doc":"Creates a new session with the given server URL.","ref":"Mcpixir.Client.html#create_session/3"},{"type":"function","title":"Mcpixir.Client.create_sessions_for_tools/2","doc":"Creates sessions for the specified tools.","ref":"Mcpixir.Client.html#create_sessions_for_tools/2"},{"type":"function","title":"Mcpixir.Client.get_session/2","doc":"Gets a session by its ID.","ref":"Mcpixir.Client.html#get_session/2"},{"type":"function","title":"Mcpixir.Client.get_tools/1","doc":"Gets all available tools.","ref":"Mcpixir.Client.html#get_tools/1"},{"type":"function","title":"Mcpixir.Client.new/1","doc":"Creates a new client with the given configuration.","ref":"Mcpixir.Client.html#new/1"},{"type":"function","title":"Mcpixir.Client.stop_all_sessions/1","doc":"Stops all sessions.","ref":"Mcpixir.Client.html#stop_all_sessions/1"},{"type":"function","title":"Mcpixir.Client.stop_session/2","doc":"Stops a session.","ref":"Mcpixir.Client.html#stop_session/2"},{"type":"type","title":"Mcpixir.Client.t/0","doc":"","ref":"Mcpixir.Client.html#t:t/0"},{"type":"module","title":"Mcpixir.Config","doc":"Configuration types and utilities for MCP.","ref":"Mcpixir.Config.html"},{"type":"function","title":"Mcpixir.Config.get_connector_type/1","doc":"Gets the connector type for a server URL.","ref":"Mcpixir.Config.html#get_connector_type/1"},{"type":"function","title":"Mcpixir.Config.load/1","doc":"Loads configuration from file and/or provided map.","ref":"Mcpixir.Config.html#load/1"},{"type":"type","title":"Mcpixir.Config.t/0","doc":"","ref":"Mcpixir.Config.html#t:t/0"},{"type":"module","title":"Mcpixir.ServerManager","doc":"Manages server connections and tool availability.","ref":"Mcpixir.ServerManager.html"},{"type":"function","title":"Mcpixir.ServerManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mcpixir.ServerManager.html#child_spec/1"},{"type":"function","title":"Mcpixir.ServerManager.get_servers_for_tools/1","doc":"Gets a list of servers that provide the requested tools.","ref":"Mcpixir.ServerManager.html#get_servers_for_tools/1"},{"type":"function","title":"Mcpixir.ServerManager.list_servers/0","doc":"Lists available servers.","ref":"Mcpixir.ServerManager.html#list_servers/0"},{"type":"function","title":"Mcpixir.ServerManager.register_server/2","doc":"Registers a new server with the manager.","ref":"Mcpixir.ServerManager.html#register_server/2"},{"type":"function","title":"Mcpixir.ServerManager.register_tools/2","doc":"Registers available tools for a server.","ref":"Mcpixir.ServerManager.html#register_tools/2"},{"type":"function","title":"Mcpixir.ServerManager.start_link/1","doc":"Starts the server manager.","ref":"Mcpixir.ServerManager.html#start_link/1"},{"type":"module","title":"Mcpixir.Session","doc":"Manages connections to MCP implementations.","ref":"Mcpixir.Session.html"},{"type":"function","title":"Mcpixir.Session.execute_tool/3","doc":"Executes a tool call.","ref":"Mcpixir.Session.html#execute_tool/3"},{"type":"function","title":"Mcpixir.Session.get_tools/1","doc":"Gets all available tools for the session.","ref":"Mcpixir.Session.html#get_tools/1"},{"type":"function","title":"Mcpixir.Session.start/3","doc":"Starts a new session with the given server URL and configuration.","ref":"Mcpixir.Session.html#start/3"},{"type":"function","title":"Mcpixir.Session.stop/1","doc":"Stops the session.","ref":"Mcpixir.Session.html#stop/1"},{"type":"type","title":"Mcpixir.Session.t/0","doc":"","ref":"Mcpixir.Session.html#t:t/0"},{"type":"behaviour","title":"Mcpixir.Agents.Base","doc":"Base behaviour for MCP agents.","ref":"Mcpixir.Agents.Base.html"},{"type":"callback","title":"Mcpixir.Agents.Base.new/1","doc":"","ref":"Mcpixir.Agents.Base.html#c:new/1"},{"type":"callback","title":"Mcpixir.Agents.Base.prepare/1","doc":"","ref":"Mcpixir.Agents.Base.html#c:prepare/1"},{"type":"callback","title":"Mcpixir.Agents.Base.run/2","doc":"","ref":"Mcpixir.Agents.Base.html#c:run/2"},{"type":"callback","title":"Mcpixir.Agents.Base.run_tool/3","doc":"","ref":"Mcpixir.Agents.Base.html#c:run_tool/3"},{"type":"module","title":"Mcpixir.Agents.MCPAgent","doc":"Agent implementation that integrates LLMs with MCP tools.","ref":"Mcpixir.Agents.MCPAgent.html"},{"type":"function","title":"Mcpixir.Agents.MCPAgent.new/1","doc":"Creates a new MCP agent with the given configuration.","ref":"Mcpixir.Agents.MCPAgent.html#new/1"},{"type":"function","title":"Mcpixir.Agents.MCPAgent.prepare/1","doc":"Prepares the agent by initializing the LLM client and loading tools.","ref":"Mcpixir.Agents.MCPAgent.html#prepare/1"},{"type":"function","title":"Mcpixir.Agents.MCPAgent.run/2","doc":"Runs a query using the agent.","ref":"Mcpixir.Agents.MCPAgent.html#run/2"},{"type":"function","title":"Mcpixir.Agents.MCPAgent.run_tool/3","doc":"Directly executes a tool using the agent.","ref":"Mcpixir.Agents.MCPAgent.html#run_tool/3"},{"type":"type","title":"Mcpixir.Agents.MCPAgent.t/0","doc":"","ref":"Mcpixir.Agents.MCPAgent.html#t:t/0"},{"type":"behaviour","title":"Mcpixir.Connectors.Base","doc":"Base behaviour for MCP connectors.","ref":"Mcpixir.Connectors.Base.html"},{"type":"function","title":"Mcpixir.Connectors.Base.close/1","doc":"Common function to close the connection.","ref":"Mcpixir.Connectors.Base.html#close/1"},{"type":"callback","title":"Mcpixir.Connectors.Base.close/1","doc":"","ref":"Mcpixir.Connectors.Base.html#c:close/1"},{"type":"type","title":"Mcpixir.Connectors.Base.connector/0","doc":"","ref":"Mcpixir.Connectors.Base.html#t:connector/0"},{"type":"function","title":"Mcpixir.Connectors.Base.execute_tool/3","doc":"Common function to execute a tool.","ref":"Mcpixir.Connectors.Base.html#execute_tool/3"},{"type":"callback","title":"Mcpixir.Connectors.Base.execute_tool/3","doc":"","ref":"Mcpixir.Connectors.Base.html#c:execute_tool/3"},{"type":"function","title":"Mcpixir.Connectors.Base.get_tools/1","doc":"Common function to get tools.","ref":"Mcpixir.Connectors.Base.html#get_tools/1"},{"type":"callback","title":"Mcpixir.Connectors.Base.get_tools/1","doc":"","ref":"Mcpixir.Connectors.Base.html#c:get_tools/1"},{"type":"function","title":"Mcpixir.Connectors.Base.initialize/1","doc":"Common initialization function for connectors.","ref":"Mcpixir.Connectors.Base.html#initialize/1"},{"type":"callback","title":"Mcpixir.Connectors.Base.initialize/1","doc":"","ref":"Mcpixir.Connectors.Base.html#c:initialize/1"},{"type":"type","title":"Mcpixir.Connectors.Base.response/0","doc":"","ref":"Mcpixir.Connectors.Base.html#t:response/0"},{"type":"module","title":"Mcpixir.Connectors.HttpConnector","doc":"HTTP connector for MCP.","ref":"Mcpixir.Connectors.HttpConnector.html"},{"type":"function","title":"Mcpixir.Connectors.HttpConnector.new/2","doc":"Creates a new HTTP connector.","ref":"Mcpixir.Connectors.HttpConnector.html#new/2"},{"type":"type","title":"Mcpixir.Connectors.HttpConnector.t/0","doc":"","ref":"Mcpixir.Connectors.HttpConnector.html#t:t/0"},{"type":"module","title":"Mcpixir.Connectors.StdioConnector","doc":"Stdio connector for MCP.","ref":"Mcpixir.Connectors.StdioConnector.html"},{"type":"function","title":"Mcpixir.Connectors.StdioConnector.new/2","doc":"Creates a new stdio connector.","ref":"Mcpixir.Connectors.StdioConnector.html#new/2"},{"type":"type","title":"Mcpixir.Connectors.StdioConnector.t/0","doc":"","ref":"Mcpixir.Connectors.StdioConnector.html#t:t/0"},{"type":"module","title":"Mcpixir.Connectors.WebSocketConnector","doc":"WebSocket connector for MCP.","ref":"Mcpixir.Connectors.WebSocketConnector.html"},{"type":"function","title":"Mcpixir.Connectors.WebSocketConnector.new/2","doc":"Creates a new WebSocket connector.","ref":"Mcpixir.Connectors.WebSocketConnector.html#new/2"},{"type":"type","title":"Mcpixir.Connectors.WebSocketConnector.t/0","doc":"","ref":"Mcpixir.Connectors.WebSocketConnector.html#t:t/0"},{"type":"behaviour","title":"Mcpixir.TaskManagers.Base","doc":"Base behaviour for task managers.","ref":"Mcpixir.TaskManagers.Base.html"},{"type":"type","title":"Mcpixir.TaskManagers.Base.manager/0","doc":"","ref":"Mcpixir.TaskManagers.Base.html#t:manager/0"},{"type":"callback","title":"Mcpixir.TaskManagers.Base.new/1","doc":"","ref":"Mcpixir.TaskManagers.Base.html#c:new/1"},{"type":"callback","title":"Mcpixir.TaskManagers.Base.send_event/3","doc":"","ref":"Mcpixir.TaskManagers.Base.html#c:send_event/3"},{"type":"callback","title":"Mcpixir.TaskManagers.Base.start/1","doc":"","ref":"Mcpixir.TaskManagers.Base.html#c:start/1"},{"type":"callback","title":"Mcpixir.TaskManagers.Base.stop/1","doc":"","ref":"Mcpixir.TaskManagers.Base.html#c:stop/1"},{"type":"module","title":"Mcpixir.TaskManagers.SSEManager","doc":"Task manager that sends events using Server-Sent Events (SSE).","ref":"Mcpixir.TaskManagers.SSEManager.html"},{"type":"module","title":"Mcpixir.TaskManagers.StdioManager","doc":"Task manager that outputs events to stdio.","ref":"Mcpixir.TaskManagers.StdioManager.html"},{"type":"module","title":"Mcpixir.TaskManagers.WebSocketManager","doc":"Task manager that sends events over WebSocket.","ref":"Mcpixir.TaskManagers.WebSocketManager.html"},{"type":"type","title":"Mcpixir.TaskManagers.WebSocketManager.t/0","doc":"","ref":"Mcpixir.TaskManagers.WebSocketManager.html#t:t/0"},{"type":"module","title":"Mcpixir.Adapters.LangChainAdapter","doc":"Adapter to convert MCP tools to LangChain compatible tools.","ref":"Mcpixir.Adapters.LangChainAdapter.html"},{"type":"function","title":"Mcpixir.Adapters.LangChainAdapter.convert_tool/2","doc":"Converts a single MCP tool to LangChain format.","ref":"Mcpixir.Adapters.LangChainAdapter.html#convert_tool/2"},{"type":"function","title":"Mcpixir.Adapters.LangChainAdapter.convert_tools/2","doc":"Converts MCP tools to LangChain format.","ref":"Mcpixir.Adapters.LangChainAdapter.html#convert_tools/2"},{"type":"function","title":"Mcpixir.Adapters.LangChainAdapter.process_tool_result/1","doc":"Processes the result from a tool execution to match LangChain expectations.","ref":"Mcpixir.Adapters.LangChainAdapter.html#process_tool_result/1"},{"type":"extras","title":"README","doc":"Unified MCP Client Library for Elixir \n\n[![License](https://img.shields.io/github/license/ramonlimaramos/mcpixir)](https://github.com/ramonlimaramos/mcpixir/blob/main/LICENSE)\n[![Elixir Version](https://img.shields.io/badge/elixir-v1.15%2B-blue)](https://elixir-lang.org/)\n[![Hex.pm Version](https://img.shields.io/hexpm/v/mcpixir.svg)](https://hex.pm/packages/mcpixir)\n[![Hex.pm Downloads](https://img.shields.io/hexpm/dt/mcpixir.svg)](https://hex.pm/packages/mcpixir)\n\n🌐 Mcpixir is the open source way to connect **any LLM to any MCP server** and build custom agents that have tool access, without using closed source or application clients.\n\n💡 Let developers easily connect any LLM to tools like web browsing, file operations, and more.\n\n# Features","ref":"readme.html"},{"type":"extras","title":"✨ Key Features - README","doc":"| Feature                         | Description                                                                                            |\n| ------------------------------- | ------------------------------------------------------------------------------------------------------ |\n| 🔄 **Ease of use**              | Create your first MCP capable agent you need only 6 lines of code                                      |\n| 🤖 **LLM Flexibility**          | Works with any LLM that supports tool calling (OpenAI, Anthropic, etc.)                                |\n| 🌐 **HTTP Support**             | Direct connection to MCP servers running on specific HTTP ports                                        |\n| ⚙️ **Dynamic Server Selection** | Agents can dynamically choose the most appropriate MCP server for a given task from the available pool |\n| 🧩 **Multi-Server Support**     | Use multiple MCP servers simultaneously in a single agent                                              |\n| 🛡️ **Tool Restrictions**        | Restrict potentially dangerous tools like file system or network access                                |\n\n# Quick start\n\nAdd `mcpixir` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:mcpixir, \"~> 0.1.0\"}\n  ]\nend\n```\n\nOr install from source:\n\n```bash\ngit clone https://github.com/yourusername/mcpixir.git\ncd mcpixir\nmix deps.get\nmix compile\n```","ref":"readme.html#key-features"},{"type":"extras","title":"Configuring LLM Providers - README","doc":"Mcpixir works with various LLM providers. You'll need to configure your preferred LLM in your application. Add your API keys for the provider you want to use to your environment variables:\n\n```bash\nexport OPENAI_API_KEY=your_openai_key_here\nexport ANTHROPIC_API_KEY=your_anthropic_key_here\n```\n\n> **Important**: Only models with tool calling capabilities can be used with Mcpixir. Make sure your chosen model supports function calling or tool use.","ref":"readme.html#configuring-llm-providers"},{"type":"extras","title":"Spin up your agent: - README","doc":"```elixir\n# Create configuration dictionary\nconfig = %{\n  mcpServers: %{\n    playwright: %{\n      command: \"npx\",\n      args: [\"@playwright/mcp@latest\"],\n      env: %{\n        DISPLAY: \":1\"\n      }\n    }\n  }\n}\n\n# Create MCP client from configuration dictionary\nclient = Mcpixir.new_client(config)\n\n# Configure LLM\nllm_config = %{\n  provider: :openai,\n  model: \"gpt-4o\"\n}\n\n# Create agent\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client\n})\n\n# Run the query\n{:ok, result, updated_agent} = Mcpixir.run(agent, \"Find the best restaurant in San Francisco\")\nIO.puts(\"\\nResult: #{result}\")\n```\n\nYou can also add the servers configuration from a config file like this:\n\n```elixir\nconfig_path = Path.join(\"path/to\", \"browser_mcp.json\")\n{:ok, config_data} = File.read(config_path)\n{:ok, config} = Jason.decode(config_data)\n\nclient = Mcpixir.new_client(config)\n```\n\nExample configuration file (`browser_mcp.json`):\n\n```json\n{\n  \"mcpServers\": {\n    \"playwright\": {\n      \"command\": \"npx\",\n      \"args\": [\"@playwright/mcp@latest\"],\n      \"env\": {\n        \"DISPLAY\": \":1\"\n      }\n    }\n  }\n}\n```\n\nFor other settings, models, and more, check out the documentation.\n\n# Example Use Cases","ref":"readme.html#spin-up-your-agent"},{"type":"extras","title":"Web Browsing with Playwright - README","doc":"```elixir\n# Create configuration\nconfig = %{\n  mcpServers: %{\n    playwright: %{\n      command: \"npx\",\n      args: [\"@playwright/mcp@latest\"],\n      env: %{\n        DISPLAY: \":1\"\n      }\n    }\n  }\n}\n\n# Create the MCP client\nclient = Mcpixir.new_client(config)\n\n# Configure LLM\nllm_config = %{\n  provider: :openai,\n  model: \"gpt-4o\"\n  # Alternative models:\n  # provider: :anthropic, model: \"claude-3-5-sonnet\"\n  # provider: :groq, model: \"llama3-8b-8192\"\n}\n\n# Create agent\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client\n})\n\n# Run the query\n{:ok, result, updated_agent} = Mcpixir.run(agent, \"Find the best restaurant in San Francisco USING GOOGLE SEARCH\")\nIO.puts(\"\\nResult: #{result}\")\n\n# Ensure we clean up resources properly\nMcpixir.Client.stop_all_sessions(client)\n```","ref":"readme.html#web-browsing-with-playwright"},{"type":"extras","title":"Airbnb Search - README","doc":"```elixir\n# Create configuration with Airbnb\nconfig = %{\n  mcpServers: %{\n    airbnb: %{\n      command: \"npx\",\n      args: [\"-y\", \"@openbnb/mcp-server-airbnb\", \"--ignore-robots-txt\"]\n    }\n  }\n}\n\n# Create the MCP client\nclient = Mcpixir.new_client(config)\n\n# Configure LLM\nllm_config = %{\n  provider: :anthropic,\n  model: \"claude-3-5-sonnet\"\n}\n\n# Create agent\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client\n})\n\n# Run a query to search for accommodations\nquery = \"\"\"\nFind me a nice place to stay in Barcelona for 2 adults\nfor a week in August. I prefer places with a pool and\ngood reviews. Show me the top 3 options.\n\"\"\"\n\n{:ok, result, updated_agent} = Mcpixir.run(agent, query)\nIO.puts(\"\\nResult: #{result}\")\n\n# Ensure we clean up resources properly\nMcpixir.Client.stop_all_sessions(client)\n```\n\nExample configuration file (`airbnb_mcp.json`):\n\n```json\n{\n  \"mcpServers\": {\n    \"airbnb\": {\n      \"command\": \"npx\",\n      \"args\": [\"-y\", \"@openbnb/mcp-server-airbnb\"]\n    }\n  }\n}\n```","ref":"readme.html#airbnb-search"},{"type":"extras","title":"Blender 3D Creation - README","doc":"```elixir\n# Create configuration with Blender\nconfig = %{\n  mcpServers: %{\n    blender: %{\n      command: \"uvx\",\n      args: [\"blender-mcp\"]\n    }\n  }\n}\n\n# Create the MCP client\nclient = Mcpixir.new_client(config)\n\n# Configure LLM\nllm_config = %{\n  provider: :anthropic,\n  model: \"claude-3-5-sonnet\"\n}\n\n# Create agent\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client\n})\n\n# Run the query\n{:ok, result, updated_agent} = Mcpixir.run(agent, \"Create an inflatable cube with soft material and a plane as ground.\")\nIO.puts(\"\\nResult: #{result}\")\n\n# Ensure we clean up resources properly\nMcpixir.Client.stop_all_sessions(client)\n```\n\n# Configuration Options\n\nMCP-Use supports initialization from configuration files, making it easy to manage and switch between different MCP server setups:\n\n```elixir\n# Load configuration from file\nconfig_path = Path.join(\"path/to\", \"mcp-config.json\")\n{:ok, config_data} = File.read(config_path)\n{:ok, config} = Jason.decode(config_data)\n\n# Create an MCP client from config\nclient = Mcpixir.new_client(config)\n\n# Create and initialize a session\n{:ok, client, session} = Mcpixir.Client.create_session(client, \"http://localhost:8000\")\n\n# Use the session...\n\n# Disconnect when done\nMcpixir.Client.stop_session(client, session.id)\n```","ref":"readme.html#blender-3d-creation"},{"type":"extras","title":"HTTP Connection Example - README","doc":"Mcpixir supports HTTP connections, allowing you to connect to MCP servers running on specific HTTP ports. This feature is particularly useful for integrating with web-based MCP servers.\n\nHere's an example of how to use the HTTP connection feature:\n\n```elixir\n# Configuration with HTTP connection\nconfig = %{\n  mcpServers: %{\n    http: %{\n      url: \"http://localhost:8931/sse\"\n    }\n  }\n}\n\n# Create the MCP client\nclient = Mcpixir.new_client(config)\n\n# Configure LLM\nllm_config = %{\n  provider: :openai,\n  model: \"gpt-4o\"\n}\n\n# Create agent\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client\n})\n\n# Run the query\n{:ok, result, updated_agent} = Mcpixir.run(agent, \"Find the best restaurant in San Francisco USING GOOGLE SEARCH\")\nIO.puts(\"\\nResult: #{result}\")\n```\n\nThis example demonstrates how to connect to an MCP server running on a specific HTTP port. Make sure to start your MCP server before running this example.\n\n# Multi-Server Support\n\nMcpixir allows configuring and connecting to multiple MCP servers simultaneously using the `Mcpixir.Client`. This enables complex workflows that require tools from different servers, such as web browsing combined with file operations or 3D modeling.","ref":"readme.html#http-connection-example"},{"type":"extras","title":"Configuration - README","doc":"You can configure multiple servers in your configuration file:\n\n```json\n{\n  \"mcpServers\": {\n    \"airbnb\": {\n      \"command\": \"npx\",\n      \"args\": [\"-y\", \"@openbnb/mcp-server-airbnb\", \"--ignore-robots-txt\"]\n    },\n    \"playwright\": {\n      \"command\": \"npx\",\n      \"args\": [\"@playwright/mcp@latest\"],\n      \"env\": {\n        \"DISPLAY\": \":1\"\n      }\n    }\n  }\n}\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - README","doc":"The `Mcpixir.Client` module provides functions for managing connections to multiple servers. When creating an agent, you can provide a client configured with multiple servers.\n\nBy default, the agent will have access to tools from all configured servers. If you need to target a specific server for a particular task, you can specify the server parameters when creating the agent.\n\n```elixir\n# Create client with multiple servers\nconfig = load_multi_server_config()\nclient = Mcpixir.new_client(config)\n\n# Example: Running a query that may use tools from both servers\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client\n})\n\n# Query combining different capabilities\nquery = \"\"\"\nSearch for a nice place to stay in Barcelona on Airbnb,\nthen use Google to find nearby restaurants and attractions.\n\"\"\"\n\n{:ok, result, _updated_agent} = Mcpixir.run(agent, query)\n```","ref":"readme.html#usage"},{"type":"extras","title":"Dynamic Server Selection (Server Manager) - README","doc":"For enhanced efficiency and to reduce potential agent confusion when dealing with many tools from different servers, you can leverage the built-in server manager functionality.\n\nWhen enabled, the agent intelligently selects the correct MCP server based on the tool chosen by the LLM for a specific step. This minimizes unnecessary connections and ensures the agent uses the appropriate tools for the task.\n\n```elixir\n# Create client with multiple servers\nconfig = load_multi_server_config()\nclient = Mcpixir.new_client(config)\n\n# Create agent with server manager enabled\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client,\n  use_server_manager: true  # Enable the Server Manager\n})\n\n# Run a query that uses tools from multiple servers\n{:ok, result, _updated_agent} = Mcpixir.run(agent, \"\"\"\n  Search for a nice place to stay in Barcelona on Airbnb,\n  then use Google to find nearby restaurants and attractions.\n\"\"\")\n```\n\n# Tool Access Control\n\nMCP-Use allows you to restrict which tools are available to the agent, providing better security and control over agent capabilities:\n\n```elixir\n# Create client\nconfig = load_config()\nclient = Mcpixir.new_client(config)\n\n# Create agent with restricted tools\n{:ok, agent} = Mcpixir.new_agent(%{\n  llm: llm_config,\n  client: client,\n  disallowed_tools: [\"file_system\", \"network\"]  # Restrict potentially dangerous tools\n})\n\n# Run a query with restricted tool access\n{:ok, result, _updated_agent} = Mcpixir.run(agent, \"Find the best restaurant in San Francisco\")\n```\n\n# Running Examples\n\nWe provide a set of Mix tasks for demonstrating different aspects of the library. These tasks use real LLMs and MCP servers to showcase the full functionality.","ref":"readme.html#dynamic-server-selection-server-manager"},{"type":"extras","title":"Mix Tasks - README","doc":"Run `mix mcp` to see all available examples:\n\n```bash\nmix mcpixir\n```\n\nAvailable examples:\n\n- `mix mcpixir.chat` - Simple chat interaction with tools\n- `mix mcpixir.airbnb` - Example showing integration with Airbnb\n- `mix mcpixir.blender` - Example for controlling Blender 3D software\n- `mix mcpixir.browser` - Web browsing with Playwright\n- `mix mcpixir.filesystem` - Working with the filesystem\n- `mix mcpixir.http` - HTTP connection to MCP servers\n- `mix mcpixir.multi` - Using multiple MCP servers together\n\nTo get help on a specific example:\n\n```bash\nmix help mcpixir.chat\n```","ref":"readme.html#mix-tasks"},{"type":"extras","title":"Running Examples - README","doc":"Each example can be run with the following pattern:\n\n```bash\n# Basic usage\nmix mcpixir.chat\n\n# With options\nmix mcpixir.browser --provider=anthropic --query=\"Find the top 5 Elixir packages on Hex.pm\"\n```","ref":"readme.html#running-examples"},{"type":"extras","title":"Common Options - README","doc":"Most examples support these common options:\n\n- `--provider=[openai|anthropic]` - LLM provider to use\n- `--model=MODEL` - Specific LLM model to use\n- `--query=QUERY` - The query to send to the LLM","ref":"readme.html#common-options"},{"type":"extras","title":"API Keys - README","doc":"These examples require API keys for OpenAI or Anthropic. Set them in your environment:\n\n```bash\n# For OpenAI\nexport OPENAI_API_KEY=your-openai-key\n\n# For Anthropic\nexport ANTHROPIC_API_KEY=your-anthropic-key\n```\n\n# Debugging\n\nMcpixir provides built-in logging that helps diagnose issues in your agent implementation.","ref":"readme.html#api-keys"},{"type":"extras","title":"Configuring Logging - README","doc":"There are several ways to configure logging:","ref":"readme.html#configuring-logging"},{"type":"extras","title":"1. Environment Variable - README","doc":"Set the log level using the `MCP_USE_LOG_LEVEL` environment variable:\n\n```bash\nexport MCP_USE_LOG_LEVEL=debug  # Options: debug, info, warn, error\n```","ref":"readme.html#1-environment-variable"},{"type":"extras","title":"2. Setting Log Level Programmatically - README","doc":"You can set the log level directly in your code:\n\n```elixir\n# Set global log level\nMcpixir.Logging.set_level(:debug)  # Options: :debug, :info, :warning, :error\n```","ref":"readme.html#2-setting-log-level-programmatically"},{"type":"extras","title":"3. Configuration in mix.exs or config.exs - README","doc":"```elixir\n# In config/config.exs\nconfig :mcpixir,\n  log_level: :debug\n```\n\n# Roadmap\n\n- [x] Multiple Servers at once\n- [x] Test remote connectors (http, ws)\n- [ ] ...\n\n# Contributing\n\nWe love contributions! Feel free to open issues for bugs or feature requests.\n\n# Requirements\n\n- Elixir 1.15+\n- Erlang/OTP 25+\n- MCP implementation (like Playwright MCP)\n- LLM API access (OpenAI, Anthropic, etc.)\n\n# Contributing","ref":"readme.html#3-configuration-in-mix-exs-or-config-exs"},{"type":"extras","title":"Development Process - README","doc":"We welcome contributions to make this project better! Here are some steps to get started:\n\n```bash\n# Clone the repository\ngit clone https://github.com/yourusername/mcp-use-elixir.git\ncd mcp-use-elixir\n\n# Install dependencies\nmix deps.get\n\n# Run tests\nmix test\n\n# Run the code formatter\nmix format\n\n# Run the linter\nmix credo\n```","ref":"readme.html#development-process"},{"type":"extras","title":"Release Process - README","doc":"This project follows semantic versioning and uses a structured release process. You can release a new version using either:","ref":"readme.html#release-process"},{"type":"extras","title":"Using the Mix task - README","doc":"```bash\nmix mcp.release 0.2.0\n```","ref":"readme.html#using-the-mix-task"},{"type":"extras","title":"Using the shell script - README","doc":"```bash\n./bin/release.sh 0.2.0\n```\n\nBoth methods will:\n\n1. Check if the working directory is clean\n2. Update the version in mix.exs\n3. Update the CHANGELOG.md with the new version\n4. Run tests to ensure everything works\n5. Compile documentation\n6. Create a git commit and tag\n7. Publish to Hex.pm\n\n# License\n\nMIT","ref":"readme.html#using-the-shell-script"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.1.0] - 2025-04-19","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Initial project structure\n- Core connectivity to MCP servers\n- Support for HTTP, WebSocket, and stdio connectors\n- Server manager for handling multiple MCP servers\n- Integration with LLMs via adapters\n- Task management for different connection types\n- Mix tasks for running examples\n- Documentation and examples","ref":"changelog.html#added"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2024 Ramon Ramos\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}